@file:Suppress("UNCHECKED_CAST", "USELESS_CAST", "INAPPLICABLE_JVM_NAME")
package uts.sdk.modules.uniRegisterRequestPermissionTips;
import io.dcloud.uniapp.*;
import io.dcloud.uniapp.extapi.*;
import io.dcloud.uts.*;
import io.dcloud.uts.Map;
import io.dcloud.uts.Set;
import io.dcloud.uts.UTSAndroid;
import kotlinx.coroutines.CoroutineScope;
import kotlinx.coroutines.Deferred;
import kotlinx.coroutines.Dispatchers;
import kotlinx.coroutines.async;
import android.app.Activity;
import android.view.animation.AnimationUtils;
import android.graphics.Color;
import java.util.HashMap;
import android.text.Html;
import android.widget.LinearLayout;
import io.dcloud.uts.permissionrequest.R;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.view.View;
import android.view.ViewGroup;
import io.dcloud.uniapp.extapi.createRequestPermissionListener as uni_createRequestPermissionListener;
open class RequestPermissionTipsListener (
    open var onRequest: ((permissions: UTSArray<String>) -> Unit)? = null,
    open var onConfirm: ((permission: UTSArray<String>) -> Unit)? = null,
    open var onComplete: ((permissions: UTSJSONObject) -> Unit)? = null,
) : UTSObject()
typealias RegisterRequestPermissionTipsListener = (listener: RequestPermissionTipsListener?) -> Unit;
typealias UnregisterRequestPermissionTipsListener = (listener: RequestPermissionTipsListener?) -> Unit;
typealias SetRequestPermissionTips = (tips: UTSJSONObject) -> Unit;
var PermissionTipsView: View? = null;
var permissionTips: HashMap<String, String> = HashMap<String, String>();
var permissionListener: RequestPermissionListener? = null;
var listener: RequestPermissionTipsListener? = null;
val unregisterRequestPermissionTipsListener: UnregisterRequestPermissionTipsListener = fun(l: RequestPermissionTipsListener?){
    listener = null;
    if (permissionListener != null) {
        permissionListener!!.stop();
        permissionListener = null;
    }
    if (PermissionTipsView != null) {
        if (PermissionTipsView!!.getParent() != null) {
            PermissionTipsView!!.setAnimation(null);
            (PermissionTipsView!!.getParent() as ViewGroup).removeView(PermissionTipsView);
        }
        PermissionTipsView = null;
    }
}
;
val registerRequestPermissionTipsListener: RegisterRequestPermissionTipsListener = fun(l: RequestPermissionTipsListener?){
    listener = l;
    if (permissionListener == null) {
        permissionListener = uni_createRequestPermissionListener();
        permissionListener!!.onRequest(fun(permissions: UTSArray<String>){
            if (listener != null) {
                listener!!.onRequest?.invoke(permissions);
            }
        }
        );
        permissionListener!!.onConfirm(fun(permissions: UTSArray<String>){
            var activity = UTSAndroid.getUniActivity()!!;
            if (PermissionTipsView != null && PermissionTipsView!!.getParent() != null) {
                PermissionTipsView!!.setAnimation(null);
                (PermissionTipsView!!.getParent() as ViewGroup).removeView(PermissionTipsView);
            }
            if (permissions.length > 0) {
                PermissionTipsView = createPermissionWindow(activity, permissions);
                if (PermissionTipsView != null) {
                    (activity.findViewById(android.R.id.content) as ViewGroup).addView(PermissionTipsView!!);
                }
            }
            if (listener != null) {
                listener!!.onConfirm?.invoke(permissions);
            }
        }
        );
        permissionListener!!.onComplete(fun(permissions: UTSArray<String>){
            var activity = UTSAndroid.getUniActivity()!!;
            if (PermissionTipsView != null) {
                PermissionTipsView!!.setAnimation(AnimationUtils.loadAnimation(activity, R.anim.popupwindow_exit));
                (PermissionTipsView!!.getParent() as ViewGroup).removeView(PermissionTipsView!!);
                PermissionTipsView = null;
            }
            if (listener != null) {
                var permissionStatus = UTSJSONObject();
                for(p in permissions){
                    permissionStatus[p] = if (UTSAndroid.checkSystemPermissionGranted(UTSAndroid.getUniActivity()!!, utsArrayOf(
                        p
                    ))) {
                        "grant";
                    } else {
                        "denied";
                    }
                    ;
                }
                listener!!.onComplete?.invoke(permissionStatus);
            }
        }
        );
    }
}
;
val setRequestPermissionTips: SetRequestPermissionTips = fun(tips: UTSJSONObject){
    permissionTips.clear();
    for(k in tips){
        permissionTips.put(k, if (tips[k] != null) {
            tips[k].toString();
        } else {
            "";
        }
        );
    }
}
;
fun createPermissionWindow(activity: Activity, permissions: UTSArray<String>): ViewGroup? {
    var rootView = RelativeLayout(activity);
    rootView.setBackgroundColor(Color.TRANSPARENT);
    var backgroundView = LinearLayout(activity);
    backgroundView.setPadding(30, 0, 30, 30);
    backgroundView.setOrientation(1);
    backgroundView.setBackgroundResource(R.drawable.dcloud_permission_background);
    var permissionTipsList: UTSArray<String> = UTSArray<String>();
    for(p in permissions){
        if (permissionTips.containsKey(p) && permissionTipsList.indexOf(permissionTips.get(p)) == -1) {
            permissionTipsList.push(permissionTips.get(p)!!);
        }
    }
    for(p in permissionTipsList){
        var text = TextView(activity);
        text.setText(Html.fromHtml(p, Html.FROM_HTML_SEPARATOR_LINE_BREAK_HEADING));
        text.setPadding(0, 30, 0, 0);
        text.setTextSize((5 * UTSAndroid.getScale()).toFloat());
        text.setTextColor(Color.BLACK);
        backgroundView.addView(text);
    }
    if (backgroundView.getChildCount() == 0) {
        return null;
    }
    var rll = RelativeLayout.LayoutParams(-1, -2);
    rll.topMargin = (UTSAndroid.getStatusBarHeight() * UTSAndroid.getScale()).toInt();
    rll.leftMargin = 30;
    rll.rightMargin = 30;
    rll.bottomMargin = 30;
    rootView.addView(backgroundView, rll);
    rootView.setAnimation(AnimationUtils.loadAnimation(activity, R.anim.popupwindow_enter));
    return rootView;
}
open class RequestPermissionTipsListenerJSONObject : UTSJSONObject() {
    open var onRequest: UTSCallback? = null;
    open var onConfirm: UTSCallback? = null;
    open var onComplete: UTSCallback? = null;
}
fun unregisterRequestPermissionTipsListenerByJs(listener: RequestPermissionTipsListenerJSONObject?): Unit {
    return unregisterRequestPermissionTipsListener(if (listener != null) {
        RequestPermissionTipsListener(onRequest = fun(permissions: UTSArray<String>): Unit {
            listener!!.onRequest?.invoke(permissions);
        }, onConfirm = fun(permission: UTSArray<String>): Unit {
            listener!!.onConfirm?.invoke(permission);
        }, onComplete = fun(permissions: UTSJSONObject): Unit {
            listener!!.onComplete?.invoke(permissions);
        });
    } else {
        null;
    }
    );
}
fun registerRequestPermissionTipsListenerByJs(listener: RequestPermissionTipsListenerJSONObject?): Unit {
    return registerRequestPermissionTipsListener(if (listener != null) {
        RequestPermissionTipsListener(onRequest = fun(permissions: UTSArray<String>): Unit {
            listener!!.onRequest?.invoke(permissions);
        }, onConfirm = fun(permission: UTSArray<String>): Unit {
            listener!!.onConfirm?.invoke(permission);
        }, onComplete = fun(permissions: UTSJSONObject): Unit {
            listener!!.onComplete?.invoke(permissions);
        });
    } else {
        null;
    }
    );
}
fun setRequestPermissionTipsByJs(tips: UTSJSONObject): Unit {
    return setRequestPermissionTips(tips);
}
